﻿using MindFusion.Diagramming.Wpf;
using MindFusion.Diagramming.Wpf.Export;
using System.Diagnostics;
using System.IO;
using System.Windows;

namespace MindfusionIssues
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            const int Bottom = 0;
            const int Top = 1000;

            InitializeComponent();

            var diagram = Diagram;

            diagram.Height = Top;
            diagram.Width = Top;

            diagram.Behavior = Behavior.Modify;

            // Place items in the grid
            Random random = new Random();

            Diagram.ZoomFactor = 100;

            var stopWatch = new Stopwatch();
            stopWatch.Start();

            for (var i = 0; i < 400; i++)
            {
                var imageNode = new SvgNode()
                {
                    Transparent = true,
                };
                imageNode.Image = ImageUtils.CreateImage(".\\images\\controller.png");

                diagram.Nodes.Add(imageNode);
                diagram.Nodes.Last().Move(random.Next(Bottom, Top), random.Next(Bottom, Top));
            }

            for (var i = 0; i < 1000; i++)
            {
                var shapeNode = new ShapeNode();
                shapeNode.Bounds = new Rect(0, 0, 30, 50);

                diagram.Nodes.Add(shapeNode);
                shapeNode.Move(random.Next(Bottom, Top), random.Next(Bottom, Top));
            }

            for (var i = 0; i < 10000; i++)
            {
                var shapeNode = new ShapeNode()
                {
                    Shape = Shapes.Ellipse,
                    Bounds = new Rect(0, 0, 5, 5),
                };

                diagram.Nodes.Add(shapeNode);
                shapeNode.Move(random.Next(Bottom, Top), random.Next(Bottom, Top));
            }

            var e = stopWatch.Elapsed;
            stopWatch.Reset();
        }

        private void Import(object sender, RoutedEventArgs e)
        {
            var stopWatch = new Stopwatch();
            stopWatch.Start();

            var svgExporter = new SvgExporter();
            using var ms = new MemoryStream();

            svgExporter.Export(Diagram, ms);

            var elapsed = stopWatch.Elapsed;
            stopWatch.Reset();
        }
    }
}